import MT as mt
import pandas as pd
from time import sleep
import os
from dotenv import load_dotenv
import time
import socket
import ta

load_dotenv()

folder_dir = os.getenv('DIR')
login = int(os.getenv('LOGIN'))
pwd = os.getenv('PWD')
server = os.getenv('SERVER')
symbol = os.getenv('SYMBOL')
path = "C:/Program Files/" + folder_dir +"/terminal64.exe"
strategy_name = "Candlestick Bot"

# Create by: Admin | Forex In Thai 
# https://www.forexinthai.com
# Email: forexinthai@gmail.com
# _____                   ___       _____ _           _
#|  ______  _ __ _____  _|_ _|_ __ |_   _| |__   __ _(_)
#| |_ / _ \| '__/ _ \ \/  | || '_ \  | | | '_ \ / _` | |
#|  _| (_) | | |  __/>  < | || | |   | | | | | | (_| | |
#|_|  \___/|_|  \___/_/\_|___|_| |_  |_| |_| |_|\__,_|_|
#
# ======== โปรดอ่านทำความเข้าใจ ก่อนนำไปใช้ ==========#
#  - ไม่การันตีว่า ทุก order จะทำกำไรได้ 100 %  จากที่ผมใช้ ส่วนใหญ่ กำไร ครับ 
# -  การออก order ใช้หลักวิเคราะห์เชิงเทคนิคโดยอาศัยกราฟแท่งเทียน Mr.Munehisa Homma อ่านได้ที่บทความ https://www.forexinthai.com/1045/
# - ไม่รับประกันว่า โค๊ดที่เขียนถูกต้อง ตาม pattern 100% จริงๆ ก็เทสมาแล้วแหละ แต่ก็ไม่ได้มั่นใจขนาดนั้น 
# - ห้ามนำไปขาย ใช้ทางการค้า หรือกิจกรรมที่เกี่ยวข้องกับการแสวงผลกำไร (ห้ามแล้วนะ)
# - ยินดีให้นำโค๊ดไปต่อยอด และจะขอบคุณมากที่ให้ credit
# - อย่าเทรด lot ใหญ่ (overtrade) 
# https://www.forexinthai.com/105121/
# =================================#




def market_order(symbol, volume, order_type, deviation, magic, stoploss, take_profit,strategy_name):

    order_type_dict = {
        'buy': mt.ORDER_TYPE_BUY,
        'sell': mt.ORDER_TYPE_SELL
    }

    price_dict = {
        'buy': mt.symbol_info_tick(symbol).ask,
        'sell': mt.symbol_info_tick(symbol).bid
    }

    request = {
        "action": mt.TRADE_ACTION_DEAL,
        "symbol": symbol,
        "volume": volume,  # FLOAT
        "type": order_type_dict[order_type],
        "price": price_dict[order_type],
        "sl": stoploss,  # FLOAT
        "tp": take_profit,  # FLOAT
        "deviation": deviation,  # INTERGER
        "magic": magic,  # INTERGER
        "comment": strategy_name,
        "type_time": mt.ORDER_TIME_GTC,
        "type_filling": mt.ORDER_FILLING_IOC,  # mt.ORDER_FILLING_FOK if IOC does not work
    }

    order_result = mt.order_send(request)
    return (order_result)
    
#sell
def is_bearish_evening_star(df):
    # เงื่อนไขสำหรับแท่งเทียนแต่ละวัน
    first_candle_bullish = df['close2'] > df['open2']
    small_body_second_day = abs(df['close1'] - df['open1']) <= (df['high1'] - df['low1']) / 3
    third_candle_bearish = df['close'] < df['open']
    
    # ตำแหน่งของแท่งเทียนวันที่สองและสาม
    second_candle_gap_up = df['open1'] > df['close2']
    third_candle_closes_below_first_midpoint = df['close'] < (df['open2'] + (df['close2'] - df['open2']) / 2)
    
    # ตรวจสอบทั้งสามแท่งเทียน
    evening_star = first_candle_bullish & small_body_second_day & second_candle_gap_up & third_candle_bearish & third_candle_closes_below_first_midpoint
    return evening_star
    
#buy
def is_morning_star(df):

    # เงื่อนไขสำหรับแท่งเทียนแต่ละวัน
    first_candle_bearish = df['close2'] > df['open2']
    small_body_second_day = abs(df['close1'] - df['open1']) <= (df['high1'] - df['low1']) / 3
    third_candle_bullish = df['close'] > df['open']
    
    # ตำแหน่งของแท่งเทียนวันที่สองและสาม
    second_candle_gap_down = df['open1'] < df['close2']
    third_candle_closes_above_first_midpoint = df['close'] > (df['open2'] + (df['close2'] - df['open2']) / 2)
    
    # ตรวจสอบทั้งสามแท่งเทียน
    morning_star = first_candle_bearish & small_body_second_day & second_candle_gap_down & third_candle_bullish & third_candle_closes_above_first_midpoint
    return morning_star
    
#buy
def is_bullish_abandoned_baby(df):

    # เงื่อนไขสำหรับแท่งเทียนแต่ละวัน
    first_candle_bearish = df['close2'] > df['open2']
    doji_second_day = (abs(df['close1'] - df['open1']) <= (df['high1'] - df['low1']) / 10)
    third_candle_bullish = df['close'] > df['open']
    
    # ช่องว่างระหว่างแท่งเทียน
    second_candle_gap_down = (df['high1'] < df['low2'])
    third_candle_gap_up = (df['low'] > df['high1'])
    
    # ตรวจสอบทั้งสามแท่งเทียน
    abandoned_baby = first_candle_bearish & doji_second_day & second_candle_gap_down & third_candle_bullish & third_candle_gap_up 
    return abandoned_baby

#sell
def is_bearish_abandoned_baby(df):
    # เงื่อนไขสำหรับแท่งเทียนแต่ละวัน
    first_candle_bullish = df['close2'] > df['open2']
    doji_second_day = (abs(df['close1'] - df['open1']) <= (df['high1'] - df['low1']) / 10)
    third_candle_bearish = df['close'] < df['open']
    
    # ช่องว่างระหว่างแท่งเทียน
    second_candle_gap_up = (df['low1'] > df['high2'])
    third_candle_gap_down = (df['high'] < df['low1'])
    
    # ตรวจสอบทั้งสามแท่งเทียน
    abandoned_baby = first_candle_bullish & doji_second_day & second_candle_gap_up & third_candle_bearish & third_candle_gap_down  
    return abandoned_baby
    
  
            

#buy
def is_three_inside_up(data):
  
    
    # criteria for the first candle
    first_candle_bearish = data['close2'] < data['open2']
    
    # criteria for the second candle
    second_candle_bearish = data['close1'] < data['open1']
    second_opens_lower = data['open1'] < data['close2']
    second_closes_in_first = data['close1'] > data['open2'] and data['close1'] < data['close2']
    
    # criteria for the third candle
    third_candle_bullish = data['close'] > data['open']
    third_opens_above_second = data['open'] > data['close1']
    third_closes_above_first = data['close'] > data['close2']
    
    
    # Check if all the conditions are met
    return (first_candle_bearish and second_candle_bearish and second_opens_lower and 
        second_closes_in_first and third_candle_bullish and third_opens_above_second and 
        third_closes_above_first)
            
            
    

#sell
def is_three_inside_down(data):


    first_candle_bullish = data['close2'] > data['open2']
    
    # criteria for the second candle
    second_candle_bullish = data['close1'] > data['open1']
    second_opens_higher = data['open1'] > data['close2']
    second_closes_in_first = data['close1'] < data['close2'] and data['close1'] > data['open2']
    
    # criteria for the third candle
    third_candle_bearish = data['close'] < data['open']
    third_opens_below_second = data['open'] < data['close1']
    third_closes_below_first = data['close'] < data['close2']
    
    # Check all criteria for the pattern
    return (first_candle_bullish and second_candle_bullish and second_opens_higher and 
        second_closes_in_first and third_candle_bearish and third_opens_below_second and
        third_closes_below_first)



#buy
def is_bullish_stick_sandwich(df):
    # เงื่อนไขสำหรับแท่งเทียนแต่ละวัน
    first_candle_bullish = df['close2'] > df['open2']
    second_candle_bearish = df['close1'] < df['open1']
    third_candle_bullish = (df['close'] == df['close2']) & (df['close'] > df['open'])

    # ตรวจสอบทั้งสามแท่งเทียน
    bullish_stick_sandwich = first_candle_bullish & second_candle_bearish & third_candle_bullish
    return bullish_stick_sandwich
    
    
#sell    
def is_bearish_stick_sandwich(df):
    # เงื่อนไขสำหรับแท่งเทียนแต่ละวัน
    first_candle_bearish = df['close2'] < df['open2']
    second_candle_bullish = df['close1'] > df['open1']
    third_candle_bearish = (df['close'] == df['close2']) & (df['close'] < df['open'])

    # ตรวจสอบทั้งสามแท่งเทียน
    bearish_stick_sandwich = first_candle_bearish & second_candle_bullish & third_candle_bearish
    return bearish_stick_sandwich   

#buy    
def is_bullish_marubozu(df):
    # ตรวจสอบว่าแท่งเทียนไม่มีเงา
    no_shadows = (df['open'] == df['low']) & (df['close'] == df['high'])
    
    # ตรวจสอบว่าแท่งเทียนมีสีเขียว
    green_candle = df['close'] > df['open']
    
    # รวมเงื่อนไขของ bullish marubozu
    bullish_marubozu = no_shadows & green_candle
    return bullish_marubozu

#sell
def is_bearish_marubozu(df):
    # ตรวจสอบว่าแท่งเทียนไม่มีเงา
    no_shadows = (df['open'] == df['high']) & (df['close'] == df['low'])
    
    # ตรวจสอบว่าแท่งเทียนมีสีแดง
    red_candle = df['close'] < df['open']
    
    # รวมเงื่อนไขของ bearish marubozu
    bearish_marubozu = no_shadows & red_candle
    return bearish_marubozu   




#buy
def is_three_bullish_soldiers(df):
    return all([
        df['open2'] < df['close2'],  # first candle bullish
        df['open1'] < df['close1'],  # second candle bullish
        df['open'] < df['close'],      # third candle bullish
        df['close2'] < df['close1'], # higher closes
        df['close1'] < df['close'],
        df['open1'] > df['close2'],  # opening within the body
        df['open'] > df['close1'],
        df['open1'] < df['open'],    # ascending opens
        df['open2'] < df['open1']
    ])

#sell
def is_three_black_crows(df):
    # Adding a column to track identified patterns
 
    return all([
        df['open2'] > df['close2'],  # first candle bearish
        df['open1'] > df['close1'],  # second candle bearish
        df['open'] > df['close'],      # third candle bearish
        df['close2'] > df['close1'], # lower closes
        df['close1'] > df['close'],
        df['open1'] < df['close2'],  # opening within the body
        df['open'] < df['close1'],
        df['open1'] > df['open'],    # descending opens
        df['open2'] > df['open1']
    ])
    


def get_signal(symbol, timeframe):
    global strategy_name
    
    
    
    
    
    

    rates = mt.copy_rates_from_pos(symbol, timeframe, 1, 100)


    # Create a DataFrame
    df = pd.DataFrame(rates)
    df['time'] = pd.to_datetime(df['time'], unit='s')
    df.set_index('time', inplace=True)
    df['rsi'] = ta.momentum.rsi(df['close'], window=14)
    rsi = df.iloc[-1];
 



    ohlc = mt.copy_rates_from_pos(symbol, timeframe, 1, 3)
    ohlc_df = pd.DataFrame(ohlc)[['time', 'open', 'high', 'low', 'close']]
    ohlc_df['time'] = pd.to_datetime(ohlc_df['time'], unit='s')

    ohlc_df['open2'] = ohlc_df['open'].shift(2)
    ohlc_df['high2'] = ohlc_df['high'].shift(2)
    ohlc_df['low2'] = ohlc_df['low'].shift(2)
    ohlc_df['close2'] = ohlc_df['close'].shift(2)
    
    
    ohlc_df['open1'] = ohlc_df['open'].shift(1)
    ohlc_df['high1'] = ohlc_df['high'].shift(1)
    ohlc_df['low1'] = ohlc_df['low'].shift(1)
    ohlc_df['close1'] = ohlc_df['close'].shift(1)
    ohlc_df['rsi'] = rsi['rsi']
    
    
    candle = ohlc_df.iloc[-1];
    
    if candle['high1'] - candle['low1'] == 0:
        return False
    
   

    is_buy = False
    is_sell = False
    
   # เล่นเฉพาะช่วงกราฟไม่ผันผวน

    if (rsi['rsi'] > 80):
        print(f"----------------------------------------")
        print(f" Check Sell Only ")
        print(f"----------------------------------------")
        sell_patterns = {
        "three_black_crows": is_three_black_crows(candle),
        "bearish_abandoned_baby": is_bearish_abandoned_baby(candle),
        "three_inside_down": is_three_inside_down(candle),
        "bearish_evening_star": is_bearish_evening_star(candle),
        "bearish_stick_sandwich": is_bearish_stick_sandwich(candle)
        }

        
        for key, pattern in sell_patterns.items():
            print(f"{key}: {pattern}")
            if pattern == True:
                is_sell = True
                strategy_name = key
                break
                
               
        print(f"----------------------------------------")
        print(f" SELL: {is_sell}")
        print(f"----------------------------------------")

        
                
    elif(rsi['rsi'] < 20):    
        print(f"----------------------------------------")
        print(f" Check Buy Only ")
        print(f"----------------------------------------")
        buy_patterns = {
        "three_bullish_soldiers": is_three_bullish_soldiers(candle),
        "bullish_abandoned_baby": is_bullish_abandoned_baby(candle),
        "three_inside_up": is_three_inside_up(candle),
        "morning_star": is_morning_star(candle),
        "bullish_stick_sandwich": is_bullish_stick_sandwich(candle)
        }

        
        for key, pattern in buy_patterns.items():
            print(f"{key}: {pattern}")
            if pattern == True:
                is_buy = True
                strategy_name = key
                break
        print(f"----------------------------------------")
        print(f" BUY: {is_buy}")
        print(f"----------------------------------------")


    else:
        print(f"----------------------------------------")
        print(f" Check All ")
        print(f"----------------------------------------")
        buy_patterns = {
        "three_bullish_soldiers": is_three_bullish_soldiers(candle),
        "bullish_abandoned_baby": is_bullish_abandoned_baby(candle),
        "three_inside_up": is_three_inside_up(candle),
        "morning_star": is_morning_star(candle),
        "bullish_stick_sandwich": is_bullish_stick_sandwich(candle)
        }

        
        for key, pattern in buy_patterns.items():
            print(f"{key}: {pattern}")
            if pattern == True:
                is_buy = True
                strategy_name = key
                break
                
        sell_patterns = {
        "three_black_crows": is_three_black_crows(candle),
        "bearish_abandoned_baby": is_bearish_abandoned_baby(candle),
        "three_inside_down": is_three_inside_down(candle),
        "bearish_evening_star": is_bearish_evening_star(candle),
        "bearish_stick_sandwich": is_bearish_stick_sandwich(candle)
        }

        
        for key, pattern in sell_patterns.items():
            print(f"{key}: {pattern}")
            if pattern == True:
                is_sell = True
                strategy_name = key
                break        
    
        print(f"----------------------------------------")
        print(f" BUY: {is_buy}")
        print(f"----------------------------------------")

        print(f"----------------------------------------")
        print(f" SELL: {is_sell}")
        print(f"----------------------------------------")
    

    #print(candle)
    print(ohlc_df)
    
    if is_buy:
        return 'buy'
    elif is_sell:
        return 'sell'
    else:
        return False
        


if __name__ == '__main__':
    # connect to MetaTrader5 Terminal
    if not mt.initialize(path=path,login=login, server=server,password=pwd):
        print("Initialize() failed, error code =", mt.last_error())
        quit()

    print(" _____                   ___       _____ _           _")
    print("|  ______  _ __ _____  _|_ _|_ __ |_   _| |__   __ _(_)")
    print("| |_ / _ \| '__/ _ \ \/  | || '_ \  | | | '_ \ / _` | |")
    print("|  _| (_) | | |  __/>  < | || | |   | | | | | | (_| | |")
    print("|_|  \___/|_|  \___/_/\_|___|_| |_  |_| |_| |_|\__,_|_|")
    print("")
    
    timeframe = mt.TIMEFRAME_M1
    volume = 0.02
    deviation=20
    magic=30
    stoploss=0.0
    take_profit=0.0
    sl = 400
    tp = 400
    

    trading_allowed = True
    while trading_allowed:
        # Careful! Loop can open infinite positions!

        signal = get_signal(symbol, timeframe)
        print('signal', signal)
        print('########################################################################################################\n')

        if signal == 'buy' and mt.positions_total() == 0:
            price = mt.symbol_info_tick(symbol).ask
            point = mt.symbol_info(symbol).point
            stoploss = price - sl * point
            take_profit = price + tp * point
            res = market_order(symbol, volume, 'buy',deviation, magic, stoploss, take_profit,strategy_name)
            trading_allowed = False

        elif signal == 'sell' and mt.positions_total() == 0:
            point = mt.symbol_info(symbol).point
            price = mt.symbol_info_tick(symbol).bid
            stoploss = price + sl * point
            take_profit = price - tp * point
            res = market_order(symbol, volume, 'sell',deviation, magic, stoploss, take_profit,strategy_name)
            trading_allowed = False

        sleep(1)


